
class StreamPipe;

class StreamElement {
public:
    StreamElement( StreamPipe* _in, StreamPipe* _out );
    virtual ~StreamElement( void );

    void startThread( void );
    void waitForThread( void );

protected:
    virtual int run( void ) = 0;

    StreamPipe* in;
    StreamPipe* out;

private:
    SDL_Thread* thr;

    static int runTrampoline( void* data );
};
